CalculationsMMFF
Date: 2019-10-22

org.jmol.minimize.forcefield

## Class CalculationsMMFF

- java.lang.Object
- - org.jmol.minimize.forcefield.Calculations
  - - org.jmol.minimize.forcefield.CalculationsMMFF

-     class CalculationsMMFF
      extends Calculations

  Author:
    Bob Hanson 5/10/12 - 5/15/12

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `(package private) Calculation` | `angleCalc`
    `(package private) Calculation` | `bondCalc`
    `static int` | `DA_D`
    `static int` | `DA_DA`
    `(package private) Calculation` | `esCalc`
    `(package private) static double` | `FPAR`
    `(package private) ForceFieldMMFF` | `mmff`
    `(package private) Calculation` | `oopCalc`
    `(package private) Calculation` | `sbCalc`
    `(package private) Calculation` | `torsionCalc`
    `(package private) Calculation` | `vdwCalc`

    - ### Fields inherited from class org.jmol.minimize.forcefield.Calculations

      `ac, angleCount, bondCount, CALC_ANGLE, CALC_DISTANCE, CALC_ES, CALC_MAX, CALC_OOP, CALC_STRETCH_BEND, CALC_TORSION, CALC_VDW, calculations, da, db, dc, dd, DEG_TO_RAD, ff, ffParams, gradients, ia, ib, ic, id, isPreliminary, KCAL_TO_KJ, logData, logging, loggingEnabled, minAngles, minAtoms, minBonds, minTorsions, parA, parB, parC, RAD_TO_DEG, silent, torsionCount, v1, v2, v3`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `CalculationsMMFF(ForceField ff, java.util.Map<java.lang.Object,java.lang.Object> ffParams, MinAtom[] minAtoms, MinBond[] minBonds, MinAngle[] minAngles, MinTorsion[] minTorsions, MinPosition[] minPositions, javajs.util.Lst<MMConstraint> constraints)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `(package private) double` | `compute(int iType, java.lang.Object[] dataIn)`
    `(package private) java.lang.String` | `getDebugHeader(int iType)`
    `(package private) java.lang.String` | `getDebugLine(int iType, Calculation c)`
    `(package private) java.lang.Object` | `getParameterObj(MinObject a)`
    `(package private) java.lang.String` | `getUnits()`
    `private static boolean` | `isInvertible(MinAtom a)`
    `protected boolean` | `isLinear(int i)`
    `(package private) boolean` | `setupCalculations()`

    - ### Methods inherited from class org.jmol.minimize.forcefield.Calculations

      `addForce, addForces, appendLogData, energyAngle, energyBond, energyES, energyOOP, energyStrBnd, energyStretchBend, energyTorsion, energyVDW, getAtomList, getConstraintList, getDebugFooter, getDebugHeader2, getDebugLineC, getLogData, getParameter, pairSearch, setAngleVariables, setConstraints, setCoords, setLoggingEnabled, setOopVariables, setPairVariables, setPreliminary, setSilent, setTorsionVariables`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### FPAR

          static final double FPAR

      See Also:
        Constant Field Values

    - #### DA_D

          public static final int DA_D

      See Also:
        Constant Field Values

    - #### DA_DA

          public static final int DA_DA

      See Also:
        Constant Field Values

    - #### bondCalc

          Calculation bondCalc

    - #### angleCalc

          Calculation angleCalc

    - #### torsionCalc

          Calculation torsionCalc

    - #### oopCalc

          Calculation oopCalc

    - #### vdwCalc

          Calculation vdwCalc

    - #### esCalc

          Calculation esCalc

    - #### sbCalc

          Calculation sbCalc

    - #### mmff

          ForceFieldMMFF mmff

  - ### Constructor Detail

    - #### CalculationsMMFF

          CalculationsMMFF(ForceField ff,
                           java.util.Map<java.lang.Object,java.lang.Object> ffParams,
                           MinAtom[] minAtoms,
                           MinBond[] minBonds,
                           MinAngle[] minAngles,
                           MinTorsion[] minTorsions,
                           MinPosition[] minPositions,
                           javajs.util.Lst<MMConstraint> constraints)

  - ### Method Detail

    - #### getUnits

          java.lang.String getUnits()

      Specified by:
        `getUnits` in class `Calculations`

    - #### setupCalculations

          boolean setupCalculations()

      Specified by:
        `setupCalculations` in class `Calculations`

    - #### isLinear

          protected boolean isLinear(int i)

      Overrides:
        `isLinear` in class `Calculations`
      Returns:
        T/F

    - #### isInvertible

          private static boolean isInvertible(MinAtom a)

    - #### compute

          double compute(int iType,
                         java.lang.Object[] dataIn)

      Specified by:
        `compute` in class `Calculations`

    - #### getParameterObj

          java.lang.Object getParameterObj(MinObject a)

      Specified by:
        `getParameterObj` in class `Calculations`

    - #### getDebugHeader

          java.lang.String getDebugHeader(int iType)

      Specified by:
        `getDebugHeader` in class `Calculations`

    - #### getDebugLine

          java.lang.String getDebugLine(int iType,
                                        Calculation c)

      Overrides:
        `getDebugLine` in class `Calculations`